using UnityEngine;

namespace SwimmingInVR.Scripts
{
    public class ScoreManager : Singleton<ScoreManager>
    {
        [SerializeField] private Web web;
        [SerializeField] private int iScanFishPoints = 5;

        private int _iScore;

        // Start is called before the first frame update
        private void Start()
        {
            _iScore = 0;
        }

        public void ScanFish()
        {
            AddPoints(iScanFishPoints);
        }

        private void AddPoints(int pointsToAdd)
        {
            _iScore += pointsToAdd;

            if (_iScore <= PlayerPrefs.GetInt("Score")) return;
            PlayerPrefs.SetInt("Score", _iScore);
            web.SaveAndGetList();
        }
    }
}