# VRAR WS21 Gruppe K - Ue 2 - Marine Life Exploration <!-- omit in toc -->

"Marine Life Exploration" is our (Marianna and Marc) second VR application for the VRAR module in WiSe 2021 @ BHT.

We have implemented swimming as our locomotion technique. In our underwater world, You can discover a wide variety of fish species.

In our virtual underwater low-poly world, there is also a scoreboard. Your score is calculated based on the number of fish you find.

Your score will be assigned to a random name and can be compared to other players' scores in-game or at [https://vrarwise2021.marcstoermer.dev](https://vrarwise2021.marcstoermer.dev).

---

"Marine Life Exploration" ist unsere (Marianna und Marc) zweite VR-Anwendung für das VRAR-Modul im WiSe 2021 @ BHT.

Wir haben das Schwimmen als unsere Fortbewegungsmethode implementiert. In unserer Unterwasserwelt kannst du eine große Vielfalt an Fischen entdecken.

In unserer virtuellen Unterwasser-Low-Poly-Welt gibt es auch eine Rangliste. Dein Score erhöht sich mit jedem Fisch, den du findest.

Deine Punktzahl wird einem zufälligen Namen zugewiesen und kann im Spiel oder unter [https://vrarwise2021.marcstoermer.dev](https://vrarwise2021.marcstoermer.dev) mit der Punktzahl anderer Spieler verglichen werden.

![english: A table on which a user interface is displayed that shows high scores. / deutsch: Ein Tisch auf dem ein User Interface abgebildet ist, welches Highscores anzeigt.](docs/score.jpg)

## Table of contents / Inhaltsübersicht <!-- omit in toc -->

- [How to play / Wie man spielt](#how-to-play--wie-man-spielt)
  - [Controls / Steuerung](#controls--steuerung)
  - [Prerequisites / Voraussetzungen](#prerequisites--voraussetzungen)
- [The game / Das Spiel](#the-game--das-spiel)
- [Development information / Informationen zur Entwicklung](#development-information--informationen-zur-entwicklung)
  - [Requirements](#requirements)
  - [Other resources used / Andere verwendete Ressourcen](#other-resources-used--andere-verwendete-ressourcen)
  - [Use the following Build Settings](#use-the-following-build-settings)
  - [Configuration for the Score Web Server](#configuration-for-the-score-web-server)

## How to play / Wie man spielt

### Controls / Steuerung

Please stretch your hands in the desired swimming direction to swim, then press the side buttons.

While pressing both side buttons, pull your hands back to your body and then let go of the side buttons.

---

Um zu schwimmen, musst du deine Hände in die gewünschte Schwimmrichtung strecken. Halte dann die Seitentasten beider Controller gedrückt und ziehe sie schnell zurück zum Körper. Lasse die Seitentasten dann wieder los und beginne von vorne.

![english: A fish in a small coral reef. Under him a floppy disk. A VR player swims in front of the reef. / deutsch: Ein Fisch in einem kleinen Korallenriff. Unter ihm eine Diskette. EIn VR-Spieler schwimmt vor dem Riff.](docs/scan.jpg)

### Prerequisites / Voraussetzungen

## The game / Das Spiel

![english: A VR player explores an underwater world. / deutsch: Ein VR-Spieler erkundet eine Unterwasserwelt.](docs/ship.jpg)

Welcome to our Marine Life Exploration VR experience.

In our little underwater ecosystem, you can find twenty different fish species. Next to every fish, you can find a floppy disk containing information related to the corresponding fish. 

Scan the floppy disk with the scanning device in your right hand by moving the blue scanning field into the disk. You will then hear a short audio log.

To reach the highest score of 100 points, you must find and scan all twenty fish species in one run. With each scanned fish, you earn five points.

Now have fun and don't get eaten by the sharks.

***A short tutorial video at the beginning of the application explains the contents of this text and the controls with explanatory visualizations.***

---

Willkommen bei unserem Marine Life Exploration VR-Erlebnis (Erforschung von Meeresleben).

In unserem kleinen Unterwasser-Ökosystem kannst du zwanzig verschiedene Fischarten finden. Neben jedem Fisch findest du eine Diskette mit Informationen zu dem entsprechenden Fisch. 

Scanne die Diskette mit dem Lesegerät in deiner rechten Hand, indem du das blaue Scan-Feld (Kugel) in die Diskette bewegst. Du hörst dann ein kurzes Audioprotokoll.

Um die Höchstpunktzahl von 100 Punkten zu erreichen, musst du alle zwanzig Fischarten in einem Durchgang finden und scannen. Für jeden gescannten Fisch erhältst du fünf Punkte.

Und nun viel Spaß und lass dich nicht von den Haien fressen.

***Ein kurzes Tutorial-Video zu Beginn der Anwendung erklärt den Inhalt dieses Textes und die Steuerung noch einmal mit erklärenden Visualisierungen.***

![englsh: A video is played in an underwater world. / deutsch: In einer Unterwasser-Welt wird ein Video abgespielt.](docs/tutorial.jpg)

![english: Two hands are held anxiously in front of the face of a shark's mouth. / deutsch: Zwei Hände werden ängstlich vor das Gesicht eines Haifischmauls gehalten.](docs/shark.jpg)

## Development information / Informationen zur Entwicklung

### Requirements

> Unity version: 2020.3.20f1 (LTS)

| Asset/Package | Version | Usage |
|--- | --- | --- |
| [Oculus Integration](https://assetstore.unity.com/packages/tools/integration/oculus-integration-82022) | 33.0 | Required for development for the Oculus Quest 2 |
| [Low Poly Underwater Pack](https://assetstore.unity.com/packages/3d/environments/landscapes/low-poly-underwater-pack-197874) | 1.0.2  | 3D assets |
| [Underwater FX](https://assetstore.unity.com/packages/vfx/particles/environment/underwater-fx-61157) | 1.6 | 3D assets |
| [ProBuilder](https://docs.unity3d.com/Packages/com.unity.probuilder@4.5/manual/index.html) | 4.5.2 | Level design + textures |
| [TextMeshPro](docs.unity3d.com/Packages/com.unity.textmeshpro@3.0/index.html) | 3.0.6 | High resolution texts/fonts in the GUI |

*TextMeshPro can be installed directly in Unity:<br>
Window → TextMeshPro → Import TMP Essential Resources*

### Other resources used / Andere verwendete Ressourcen

For the audio logs we used [https://glados.c-net.org/](https://glados.c-net.org/) (Test-To-GLaDOS). Attention! You should upload no personal data to this tool. All texts and recordings are stored indefinitely and made public.

We have collected the information about the individual fish species we use in the AudioLogs from various sources. You can find the references in [Assets/SwimmingInVR/AudioLogs/Audiolog_Sources.txt](Assets/SwimmingInVR/AudioLogs/Audiolog_Sources.txt).

The floppy disk, the hands of the player, and the scanner are 3D models which were made available under [Creative Commons Attribution 4.0 International (CC BY 4.0)](creativecommons.org/licenses/by/4.0/). In some cases, we have made changes to the 3D models. Information in [Assets/SwimmingInVR/Models/Licenses.txt](Assets/SwimmingInVR/Models/Licenses.txt).

---

Für die Tonaufnahmen verwenden wir [https://glados.c-net.org/](https://glados.c-net.org/) (Test-To-GLaDOS). Achtung! Es sollten keine persönlichen Daten in dieses Tool hochgeladen werden. Alle Texte und Aufnahmen werden auf unbestimmte Zeit gespeichert und öffentlich zugänglich gemacht.

Wir haben die Informationen über die einzelnen Fischarten, die wir in den AudioLogs verwenden, aus verschiedenen Quellen zusammengetragen. Sie finden die Referenzen in [Assets/SwimmingInVR/AudioLogs/Audiolog_Sources.txt](Assets/SwimmingInVR/AudioLogs/Audiolog_Sources.txt).

Die Diskette, die Hände des Spielers und der Scanner sind 3D-Modelle, die unter [Creative Commons Attribution 4.0 International (CC BY 4.0)](creativecommons.org/licenses/by/4.0/) zur Verfügung gestellt wurden. In einigen Fällen haben wir Änderungen an den 3D-Modellen vorgenommen. Informationen in [Assets/SwimmingInVR/Models/Licenses.txt](Assets/SwimmingInVR/Models/Licenses.txt).

### Use the following Build Settings

 > Source: https://developer.oculus.com/documentation/unity/unity-conf-settings/
 
  - Platform: Android
  - Texture Compression: ASTC
  - Run Device: OUR OCULUS 2 DEVICE
  - Development Build: Checked (for testing)
  - Compression Methode: LZ4

### Configuration for the Score Web Server

Create a C# script "WebConfig" with the following content:

```c#
public static class WebConfig
{
    public const string AppKey = "app_key2";
}
```

*Change "app_key2" to your app_key from the .env of [score-web-server](https://gitlab.beuth-hochschule.de/vrar-ws21-gruppe-k/score-web-server)*

